using System;
using Neo.Core;
using Neo.SqlClient;
using NihonUnisys.NeoStore.Model;

namespace NihonUnisys.NeoStore.UI
{
	public class PriceRaiser1
	{
		public void Execute()
		{
			//	ObjectContext̎擾
			IDataStore ds = new SqlDataStore("Server=localhost;Database=Spiking;User ID=spiking;Password=spiking2005;");
			ObjectContext oc = new ObjectContext(ds);

			//	iB
			this.RaiseAllProductPrice(oc);

			//	݂̃f[^Sĕ\B
			this.ShowAll(oc);

			//	ύXʂRDBMSɏ݁B
			oc.SaveChanges();
		}

		private void ShowAll(ObjectContext oc)
		{
			//	SB
			CategoryList cs = new CategoryFactory(oc).FindAllObjects();
			foreach (Category c in cs)
			{
				Console.WriteLine("Category: name = {0}", c.Name);

				//	qe[uւ̃ANZXB
				foreach (Product p in c.Products)
				{
					Console.WriteLine("\tProduct: name = {0}, price = {1:c}", p.Name, p.Price);
				}

				Console.WriteLine();
			}
		}

		private void RaiseAllProductPrice(ObjectContext oc)
		{
			//	w肵Ă̌B
			ProductList ps = new ProductFactory(oc).Find("Name={0}", "VAIO TypeU");
			foreach (Product p in ps)
			{
				//	\bȟĂяoB
				p.RaiseThePrice(1.05m);
			}
		}
	}
}
