using System;
using System.Data;
using Neo.Core;
using NihonUnisys.NeoStore.Model;

namespace NihonUnisys.NeoStore.UI
{
	public class PriceRaiser2
	{
		public void Execute()
		{
			//	DataSet𐶐B
			using (DataSet ds = new DataSet())
			{
				//	Visual Studio .NET 2003ŐAf[^EANZX̂߂̃NXB
				CategoryComponent cc = new CategoryComponent();
				ProductComponent pc = new ProductComponent();

				//	NeoȊO̕@Ńf[^ǂݍ݁B
				cc.Fill(ds);
				pc.Fill(ds);

				//	f[^E\[Xw*Ȃ*ObjectContext쐬B
				ObjectContext oc = new ObjectContext();

				//	DataSetNeoɃ}[WB
				oc.MergeData(ds);

				//	NeoŃf[^擾ꍇƓ悤Ƀ\bhĂяoB
				this.RaiseAllProductPrice(oc);
				this.ShowAll(oc);

				//	NeoȊO̕@Ńf[^݁B
				pc.Update(oc.DataSet);				
			}
		}

		private void ShowAll(ObjectContext oc)
		{
			//	NeoŃf[^擾ꍇƓR[hB
			CategoryList cs = new CategoryFactory(oc).FindAllObjects();
			foreach (Category c in cs)
			{
				Console.WriteLine("Category: name = {0}", c.Name);
				foreach (Product p in c.Products)
				{
					Console.WriteLine("\tProduct: name = {0}, price = {1:c}", p.Name, p.Price);
				}
				Console.WriteLine();
			}
		}

		private void RaiseAllProductPrice(ObjectContext oc)
		{
			//	NeoŃf[^擾ꍇƓR[hB
			ProductList ps = new ProductFactory(oc).Find("Name={0}", "VAIO TypeU");
			foreach (Product p in ps)
			{
				p.RaiseThePrice(1.05m);
			}
		}
	}
}
